// WADsp.cpp : Defines the entry point for the application.
//

#include "stdafx.h"

#define APP_NAME "WADsp 1.3"

// Global Variables:
HWND			mainWnd;
HINSTANCE		hDllInstance;
winampDSPModule*module;
WNDPROC			oldModuleWndProc;


LRESULT CALLBACK ModuleWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (message == WM_SYSCOMMAND) 
	{
		switch (wParam)
		{
		case SC_CLOSE:	
			PostQuitMessage(0);
			return 0;
		case IDM_ABOUT:	
			MessageBox(hWnd,"Winamp DSP plug-in launcher\n\n(c) 2002 by Olivier Marcoux", APP_NAME, MB_ICONINFORMATION);
			return 0;
		case IDM_CONFIG:
			module->Config(module);
			return 0;
		}
	}
	return CallWindowProc(oldModuleWndProc,hWnd,message,wParam,lParam);
}

BOOL StartupInstance(HINSTANCE hInstance, LPSTR lpCmdLine, int nCmdShow)
{
	char line[256];
	strcpy(line, lpCmdLine);
	char *scan = strtok(line," ");
	if (scan == NULL)
	{
		if (!PathFileExists("dsp_sc.dll"))
		{
			char path[256];
			DWORD pathLen = sizeof(path);
			CRegKey regKey;
			regKey.Open(HKEY_CURRENT_USER,"SOFTWARE\\Winamp", KEY_READ);
			if (regKey.QueryValue(path,NULL,&pathLen) == ERROR_SUCCESS)
			{
				SetCurrentDirectory(path);
				SetCurrentDirectory("plugins");
			}
			regKey.Close();

		}

		strcpy(line, "dsp_sc.dll");
	    scan = strtok(line," ");
	}

	/*
	if (scan == NULL) 
	{
		MessageBox(0,	"Usage:\n"
						"   WADsp.exe <nom du dsp.dll> <numro de fonction (default:0)> [connect]\n\n"
						"(pensez  spcifier dans le raccourci le repertoire initial contenant\n"
						"les fichiers necessaires au DSP)", NULL, MB_ICONINFORMATION );
	}*/

	bool isShoutcast = (strcmp(scan,"dsp_sc.dll") == 0);
	hDllInstance = LoadLibrary(scan);
	if (!hDllInstance)
	{
		int err = GetLastError();
		MessageBox(0,	"DLL introuvable. Chemin d'accs incorrect ?\n"
						"(pensez  spcifier dans le raccourci le repertoire initial contenant\n"
						"les fichiers necessaires au DSP)", scan, MB_ICONERROR); 
		char tmp[100];
		GetCurrentDirectory(sizeof(tmp),tmp);
		return FALSE; 
	}
    scan = strtok(NULL," ");
	if (scan == NULL) scan = "0";

	mainWnd = CreateWindow(MAKEINTATOM(32770), APP_NAME, WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, 0, 275, 14, NULL, NULL, hInstance, NULL);
	if (!mainWnd) return FALSE;
	
	winampDSPGetHeaderType getHeaderFunc = (winampDSPGetHeaderType) GetProcAddress(hDllInstance, "winampDSPGetHeader2");
    if (!getHeaderFunc)
	{
		MessageBox(0, "Erreur lors de GetProcAddress", NULL, 0);
		return FALSE;
	}
    winampDSPHeader *header = getHeaderFunc();
    if (!header)
	{
		MessageBox(0, "Erreur lors de getHeaderFunc", NULL, 0);
		return FALSE;
	}
    module = header->getModule(atoi(scan));
    if (!module)
	{
		MessageBox(0, "Numro de fonction plug-in incorrecte", NULL, 0);
		return FALSE;
	}
    module->hwndParent = mainWnd;
    module->hDllInstance = hDllInstance;
	if (module->Init(module))
	{
		MessageBox(0, "Erreur  l'Init du module", NULL, 0); 
	    return FALSE; 
	}
    HWND moduleWnd = GetNextWindow(mainWnd, GW_HWNDPREV);
	ShowWindow(moduleWnd,SW_HIDE);
    
	int style = GetWindowLong(moduleWnd, GWL_STYLE);
    SetWindowLong(moduleWnd, GWL_STYLE, style | WS_SYSMENU|WS_MINIMIZEBOX);
	style = GetWindowLong(moduleWnd, GWL_EXSTYLE);
    SetWindowLong(moduleWnd, GWL_EXSTYLE, style & ~WS_EX_DLGMODALFRAME & ~WS_EX_TOOLWINDOW | WS_EX_APPWINDOW);
	SetClassLong(moduleWnd, GCL_HICON, (LONG) LoadIcon(hInstance, MAKEINTRESOURCE(IDI_WINAMP)));
	int cx,cy;
	RECT rect, rect2;	
    GetWindowRect(mainWnd,&rect);
	GetWindowRect(moduleWnd,&rect2);
	cx = rect2.right-rect2.left;
    cy = rect2.bottom-rect2.top;
	if (cx <= 0x0A) cx = 275;
    if (cy <= 0x0A) cy = 116;
    SetWindowPos(moduleWnd,0,rect.left,rect.top,cx,cy,SWP_NOZORDER);
	oldModuleWndProc = (WNDPROC) GetWindowLong(moduleWnd,GWL_WNDPROC);
	SetWindowLong(moduleWnd, GWL_WNDPROC, (LONG) ModuleWndProc);

	GetSystemMenu(moduleWnd,TRUE);
	InsertMenu(GetSystemMenu(moduleWnd,FALSE), 0, MF_BYPOSITION, SC_MINIMIZE, "R&duction");
	InsertMenu(GetSystemMenu(moduleWnd,FALSE), 0, MF_BYPOSITION | MF_SEPARATOR, 0, NULL);
	InsertMenu(GetSystemMenu(moduleWnd,FALSE), 0, MF_BYPOSITION, IDM_CONFIG, "Configure plug-in...");
	InsertMenu(GetSystemMenu(moduleWnd,FALSE), 0, MF_BYPOSITION, IDM_ABOUT, "About WADsp...");

    ShowWindow(moduleWnd,SW_SHOWNORMAL);
    SetForegroundWindow(moduleWnd);

	scan = strtok(NULL," ");
	if (isShoutcast) {
		CheckDlgButton(moduleWnd, 0x3F4, BST_UNCHECKED);
		SendMessage(moduleWnd, WM_COMMAND, 0x3F4, NULL); // song title
		CheckDlgButton(moduleWnd, 0x3F6, BST_UNCHECKED);
		SendMessage(moduleWnd, WM_COMMAND, 0x3F6, NULL); // url
		if (scan && (strcmp(scan,"connect") == 0))
			SendMessage(moduleWnd, WM_COMMAND, 0x3F0, NULL); // connect
	}

	return TRUE;
}

void TerminateInstance(void)
{
	if (module)	module->Quit(module);
	if (hDllInstance)	FreeLibrary(hDllInstance);
	if (mainWnd)		DestroyWindow(mainWnd);
}

int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	if (StartupInstance(hInstance, lpCmdLine, nCmdShow)) 
	{
		MSG msg;
		while (GetMessage(&msg, NULL, 0, 0)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}

	}
	return 0;
}
